<div class="card">
  <h5 class="card-header">Divide by Zero</h5>
  <div class="card-body">
  	<%= link_to 'divide by Zero', dbz_divide_path , class: "btn btn-secondary" %>
  	<br>
  	<br>
    <h5 class="card-title">Report</h5>
    <p class="card-text">When any number is divided by zero then it gives us an error. Here when we click on below button it is actually calling a method which divides a number(10) by zero, hence the zero division exception is raised. It is not handled by the rails, therefore we use Rails.logger.error and added a message named "about to divide by 0 error". The Rails.logger provides no of log levels such as warning,info,debug,error or unknown.  The divide by zero exception was handled in order to get the error message. The error msg is not shown in the production server unless and until we check the flag as true in config/environments/production.rb, in that we need to make the vallue of config.consider_all_requests_local as true. 
    The error message is seen in the production.log file in the production server.
    </p>
    <br>
    <br>
    
    <h5>Screenshot of production.log file</h5>
    
    <img alt="log_image"  src="/assets/er.png">
    <br>
  </div>
</div>




<br>
<br>
<br>

<br>
	<h1> World News from New York times </h1>
<br>
 

<table style="text-align: center" class="table table-striped table-bordered">
<thead class="table-dark">
    <tr>
      <th>Heading</th>
      <th>Link</th>
    </tr>
  </thead>
  <% @result.each do |result| %>
	
	<tr>
		<td> <%= result["heading"] %> </td>
		<td> <a href="<%= result["url"] %>" > Read more about this article </a> </td>
	</tr>
	
  <% end %>

</table>
<br>

<br>
 <h1> International news from The Hindu </h1>
<br>
 
 <table style="text-align: center" class="table table-striped table-bordered">
<thead class="table-dark">
    <tr>
      <th>Heading</th>
      <th>Link</th>
    </tr>
  </thead>
  <% @result2.each do |result2| %>
	
	<tr>
		<td> <%= result2["heading"] %> </td>
		<td> <a href="<%= result2["url"] %>" > Read more about this article </a> </td>
	</tr>
	
  <% end %>

</table>

<br>
<br>

<div class="card">
  <div class="card-header">
    <h5>References and Credits</h5>
  </div>
  <div class="card-body">
    <h5 class="card-title">News</h5>
    <p class="card-text">
https://stackoverflow.com/questions/6700367/getting-all-links-of-a-webpage-using-ruby<br>
https://stackoverflow.com/questions/13185611/how-to-display-an-array-in-a-rails-view<br>
https://stackoverflow.com/questions/14319347/variables-in-ruby-on-rails<br>
https://stackoverflow.com/questions/22325895/getting-form-value-into-controller-in-ruby-on-rails<br>
https://stackoverflow.com/questions/39653384/how-to-extract-html-links-and-text-using-nokogiri-and-xpath-and-css<br>
https://medium.com/@markevan100/basic-web-scraping-in-rails-using-nokogiri-7e8a2504cbc6<br>
https://nokogiri.org/<br>
https://getbootstrap.com/<br>
https://docs.ruby-lang.org/en/2.0.0/Hash.html<br>
https://medium.com/@kamalovotash/arrays-and-hashes-in-ruby-29e3476e03da<br>
https://www.geeksforgeeks.org/how-to-make-a-custom-array-of-hashes-in-rub<br>
https://www.thehindu.com/<br>
https://www.nytimes.com/international/<br>
<br>
<h5 class="card-title">Divide by Zero</h5>
https://stackify.com/rails-logger-and-rails-logging-best-practices/<br>
<br>
<br>
    <h5 class="card-title">XHTML Validator</h5>
    We use xhtml validator in order to validate our web pages according to the w3c standards.
This helps in indentifing any broken links, or tags. This even helps in improving the raning on the search engine and so it is also a best practice to use validators. This is avilable in the footer.
<br>
<br>
    https://validator.w3.org/<br>
https://www.loginradius.com/blog/async/w3c-validation/<br>
<br>

  </div>
</div>
<br>
<br>
